################
# animat.py    #
# G.Desmeulles #
# 23/04/2013   #
# 27/07/2022   #
# S2-P MDD     #
################
import sys
import os

#le module animat gere le type abstrait de donnee animat
#un animat est un objet qui se deplace dans le terminal 

class Animat:
	pass

def create(nomDeFichier):
	myFile=open(nomDeFichier,"r")
	str=myFile.read()	
	myFile.close()
	p=str.split('\n')
	
	if p[0]!="--descriptionAnimat--":
		print("fichier animat invalide")	
		
	#creation animat
	animat=Animat()
	animat.color=int(p[1])
	animat.direction=p[2]
	animat.x=float(p[3])
	animat.y=float(p[4])
	animat.x_max=float(p[5])
	animat.y_max=float(p[6])
	animat.speed=float(p[7])
		
	return animat
	

def show(a) : 

	#on se place a la position de l animat dans le terminal
	x=str(int(a.x))
	y=str(int(a.y))
	txt="\033["+y+";"+x+"H"
	sys.stdout.write(txt)
	
	#couleur fond noire
	sys.stdout.write("\033[40m")
	
	#couleur animat
	c=a.color
	txt="\033[3"+str(c%7+1)+"m"
	sys.stdout.write(txt)

	#affichage de l animat
	sys.stdout.write("X\n")
	
def move(a,dt):

	#changement de la position de l animat en fonction du pas de temps
	if a.direction=="up":
		a.y=(a.y-(a.speed*dt))%a.y_max
	elif a.direction=="right":
		a.x=(a.x+(a.speed*dt))%a.x_max
	elif a.direction=="down":
		a.y=(a.y+(a.speed*dt))%a.y_max
	elif a.direction=="left":
		a.x=(a.x-(a.speed*dt))%a.x_max
	
def changeColor(a):

	a.color=a.color+1

def changeDirection(a):

	if a.direction=="up":
		a.direction="right"
	elif a.direction=="right":
		a.direction="down"
	elif a.direction=="down":
		a.direction="left"
	elif a.direction=="left":
		a.direction="up"

if __name__ == '__main__':
	a = create("animat.txt")
	show(a)
	move(a,1)
	changeColor(a)
	changeDirection(a)
