# -*- coding: cp1252 -*-

'''
    Mardi 9 avril 2013
    Le code fournit ici vous donne un exemple d'utilisation de l'API dom
    afin d'analyser un fichier XML.
    Ce script doit tre excut avec un fichier XML d'exemple : exemple.xml :
    <xml>
	<test>Coucou</test>
	<test>Salut</test>
	<test>Bonjour</test>
	<test>Hey</test>
	<test2 couleur="bleu" taille="3">Hello</test2>
	<test3 niveau="1">
	    <item>clef</item>
	    <item>armoire</item>
	    <item>porte</item>
	</test3>
	<test3 niveau="2">
	    <item>livre</item>
	    <item>parchemin</item>
	</test3>
	<test3 niveau="3">
	    <item>pomme</item>
	    <item>monstre</item>
	</test3>
    </xml>
    Si question : celine.jost@enib.fr
'''

'''
    Exemple de fonction qui permet de transformer une chaine de caractre
    en entier.
    Si la chaine de caractre ne peut pas tre transform en entier alors
    la fonction renvoie -1. (Par exemple, si chaine vaut "test", la fonction
    renvoie -1).
'''
def convertirEnInt(chaine):
    nombre = 0;
        
    try:
        nombre = int(chaine)
    except ValueError:
        nombre = -1;
        
    return nombre;

'''
    L'API  utiliser pour parser un fichier XML est xml.dom
    #Documentation : http://docs.python.org/2/library/xml.dom.html
'''
from xml.dom.minidom import parse;

'''
    Cette ligne permet de crer un document XML, qui est une sorte d'arbre
    qui reprsente le fichier XML. C'est une structure informatique qui
    correspond au fichier XML.
'''
doc = parse('exemple.xml');

'''
    Cette ligne permet de rcuprer la balise racine du fichier XML.
'''
rootElement = doc.documentElement;

'''
    La fonction getElementByTagName permet de rcuprer toutes les balises dont
    le nom est celui pass en paramtre. Ici on rcupre dans la variable
    testNodes l'ensemble des balises "test". testNodes est une liste.
    On connait le nombre de balises tests en appelant l'attribut length.
    Ensuite on peut parcourir chacun des lments (balises).
'''
testNodes = rootElement.getElementsByTagName("test");
size = testNodes.length;
for i in range(size):
    '''
       La variable node stocke,  chaque tour de boucle, une des balises "test"
       dans l'ordre o elles se trouvent dans le fichier.
       La proprit nodeName renvoie le nom de la balise.
       la proprit firstChild.nodeValue renvoie le texte contenu dans la balise.
    '''
    node = testNodes[i];
    print (node.nodeName, " : ", node.firstChild.nodeValue);

'''
    Ce deuxime exemple permet de voir comment on rcupre la valeur des
    attributs d'une balise. Le dbut du code est le mme que l'exemple prcdent,
    seul le contenu de la boucle diffre.
    On a rcupr cette fois l'ensemble des balises test2.
'''
testNodes2 = rootElement.getElementsByTagName("test2");
size2 = testNodes2.length;
for i in range(size2):
    node = testNodes2[i];
    '''
        La mthode hasAttributes() permet de tester si une balise contient
        des attributs.
        La mthode getAttribute() permet de rcuprer la valeur d'un attribut
        en fonction du nom de l'attribut (pass en paramtre).
        Les valeurs retournes sont toujours des chanes de caractre.
    '''
    if node.hasAttributes():
        print ("Couleur : ",node.getAttribute("couleur"));
        print ("Taille : ",node.getAttribute("taille"));


'''
    Ce dernier exemple ne vous montre rien de nouveau. C'est juste une exemple de
    code d'une balise XML un peu plus complexe.
    Cet exemple vous montre comment transformer une chane de caractre "1", "2"
    ou "3" en l'entier correspondant.
    Cela permet par exemple de n'afficher que les informations concernant les
    niveaux infrieur  3.
    Changez niveauInt<3 en niveauInt<4 pour bien comprendre.
'''
testNodes3 = rootElement.getElementsByTagName("test3");
size3 = testNodes3.length;
for i in range(size3):
    node = testNodes3[i];
    #print node.nodeName;
    if node.hasAttributes():
        niveau = node.getAttribute("niveau");
        niveauInt = convertirEnInt(niveau);
        if niveauInt<3:
            print ("Au niveau ",niveauInt, " : ");
            itemsNode = node.getElementsByTagName("item");
            itemsSize = itemsNode.length;
            for j in range(itemsSize):
                itemNode = itemsNode[j];
                print ("    ",itemNode.firstChild.nodeValue);